  function [err,val,vec]=arnSinv(A,m,v,sigma,tol,maxits)
%%--------------------
% function [err,val,v]=arnSinv(A,m,v,sigma,tol,maxits)
% restarted shift-invert Arnoldi process 
% computes eigenpair closest to shift sigma
%%-------------------- factor A - sigma I 
 [L, U, P] = lu(A - sigma * eye(size(A))) ;
 n = size(A,1);
 res = 1.0; its = 0; tol1 = 0.0;
%%--------------------  restart loop 
 while (its*m < maxits  & res > tol1) 
  its = its+1;
  ro = norm(v,2)  ; 
  t = 1.0/ ro   ;
  V(:,1) = v*t; 
  v  = P*(U\ (L\V(:,1))) ;
  val  = v'*V(:,1) ;
  r = v - val*V(:,1);
  res = norm(r);
  if (its == 1) 
    tol1 = tol*res;
  end
  err(its)  = res;
%%-------------------- arnoldi loop 
for i=1:m  
   i1 = i + 1  ; 
   V(:,i1) = P*(U\ (L\V(:,i))) ;
%%-------------------- modified GS  ;
 for j=1:i 
   t = V(:,j)'*V(:,i1)  ;
   H(j,i) = t  ;
   V(:,i1) = V(:,i1) - t*V(:,j)  ; 
  end  ;
%
  t = norm(V(:,i1),2)  ;
  H(i1,i) = t  ;
  if (t  ~= 0.0)  
   t = 1.0 / t  ;
   V(:,i1) = V(:,i1)*t  ;  
  end  
%%-------------------- Arnoldi Objects 
  Vm = V(:,1:i);
  Hm = H(1:i,1:i);
  [X,vals] = eig(Hm);
  vals = diag(vals);
  [t, k] = max(abs(vals));
  v = V(:,1:i)*X(:,k) ;
  vec = v;
  val = sigma + 1./ vals(k) ;
 end
end
